package com.diagbot.facade;

import com.diagbot.dto.RedisWithDiagnoseDTO;
import com.diagbot.service.impl.LibraryInfoServiceImpl;
import com.diagbot.util.ListUtil;
import com.diagbot.util.StringUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.dao.DataAccessException;
import org.springframework.data.redis.connection.RedisConnection;
import org.springframework.data.redis.core.RedisCallback;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.stereotype.Component;

import java.util.List;

/**
 * @Description: 术语基本信息查询业务层
 * @author: Weixuan Huang
 * @time: 2019/1/16 14:17
 */
@Component
public class LibraryInfoFacade extends LibraryInfoServiceImpl {

    @Autowired
    RedisTemplate<String, String> redisTemplate;

    public void loadRedisWithDiagnose() {
        redisTemplate.delete("diagnose");
        List<RedisWithDiagnoseDTO> libRedisVOS = this.putRedis();
        byte[] tt = "diagnose".getBytes();
        List<Object> resultList = redisTemplate.executePipelined(new RedisCallback<Object>() {
            @Override
            public String doInRedis(RedisConnection connection) throws DataAccessException {
//               1.connection 打开管道
                connection.openPipeline();
                if (ListUtil.isNotEmpty(libRedisVOS)) {
                    for (RedisWithDiagnoseDTO vo : libRedisVOS) {
                        if (StringUtil.isNotEmpty(vo.getWVal()) && StringUtil.isNotEmpty(vo.getWKey())) {
                            connection.hSet(tt, vo.getWKey().getBytes(), vo.getWVal().getBytes());
                        }
                    }
                }
                return null;
            }
        });
    }
}
